commit:     37219aee42de9387e83eb2e2454b4c7b74e5ebbe
Author:     Mike Gilbert <floppym <AT> gentoo <DOT> org>
AuthorDate: Sun Oct  9 21:16:51 2022 +0000
Commit:     Mike Gilbert <floppym <AT> gentoo <DOT> org>
CommitDate: Sat Oct 15 17:33:50 2022 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=37219aee

eclass/tests: add systemd tests

Signed-off-by: Mike Gilbert <floppym <AT> gentoo.org>

 eclass/tests/systemd.sh | 50 +++++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 50 insertions(+)

diff --git a/eclass/tests/systemd.sh b/eclass/tests/systemd.sh
new file mode 100755
index 000000000000..f870df4b7a12
--- /dev/null
+++ b/eclass/tests/systemd.sh
@@ -0,0 +1,50 @@
+#!/usr/bin/env bash
+# Copyright 2022 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=8
+source tests-common.sh || exit
+
+inherit systemd
+
+test_system_dir() {
+       local exp1="${EPREFIX}$1"
+       local exp2="${EPREFIX}/usr$1"
+       shift
+       tbegin "$@"
+       local act=$("$@")
+       [[ ${act} == ${exp1} || ${act} == ${exp2} ]]
+       tend $?
+}
+
+test_user_dir() {
+       local exp="${EPREFIX}$1"
+       shift
+       tbegin "$@"
+       local act=$("$@")
+       [[ ${act} == ${exp} ]]
+       tend $?
+}
+
+test_systemd_unprefix() {
+       local exp=$1
+       local EPREFIX=$2
+       shift 2
+       tbegin "EPREFIX=${EPREFIX} _systemd_unprefix $@"
+       [[ "$(_systemd_unprefix "$@")" == "${exp}" ]]
+       tend $?
+}
+
+test_system_dir /lib/systemd/system systemd_get_systemunitdir
+test_system_dir /lib/systemd systemd_get_utildir
+test_system_dir /lib/systemd/system-generators systemd_get_systemgeneratordir
+test_system_dir /lib/systemd/system-preset systemd_get_systempresetdir
+test_system_dir /lib/systemd/system-sleep systemd_get_sleepdir
+
+test_user_dir /usr/lib/systemd/user systemd_get_userunitdir
+
+test_systemd_unprefix /lib/systemd /prefix echo /prefix/lib/systemd
+test_systemd_unprefix /lib/systemd '' echo /lib/systemd
+test_systemd_unprefix /lib/systemd '/*' echo '/*/lib/systemd'
+
+texit

Reply via email to